/**//*   歌曲属性 感谢queplayer*/
static gchar **get_id3v1_tag(FILE *file) {

    gchar *b;
    static gchar a[130],*tag[3];
    gsize r,w;
    gint i,n;
    tag[0]=0;
    tag[1]=0;
    tag[2]=0;
    if (fseek(file,-128,2)==-1) {
        //printf("get_id3v1_tag error :seek file error\n");
        return NULL;
    }
    if (!fread(a,128,1,file)) {
        //printf("get_id3v1_tag error:read file error\n");
        return NULL;
    };
    b=a;
    if (*b=='T'&&*(b+1)=='A'&&*(b+2)=='G') {
        b+=3;
        for (n=0;n<3;n++) {
            if (n==0)tag[2]=b;
            else if (n==1)tag[0]=b;
            else if (n==2)tag[1]=b;
            b+=30;
            for (i=1;!(*(b-i)>=33&&*(b-i)<=122);i++)
                if (*(b-i)==0)break;
                else if (*(b-i)==32)
                    *(b-i)=0;
        }
        for (i=0;i<3;i++)
            if (!g_utf8_validate(tag[i],-1,NULL))tag[i]=g_convert(tag[i],-1,"UTF-8","GBK",&r,&w,NULL);

        return tag;
    }
    return NULL;
}
static gchar **get_id3v2_tag(FILE *file) {

    gchar *a,*c,b[5],*d;
    static gchar tag[3][64],*tag_[3];
    gint j,header_size,version;
    long i;
    gint size[4],tag_type;
    gsize r,w;
    *tag[0]=0;
    tag_[0]=tag[0];
    *tag[1]=0;
    tag_[1]=tag[1];
    *tag[2]=0;
    tag_[2]=tag[2];
    a=(gchar*)malloc(10);
    if (fread(a,10,1,file));
    if (*a=='I'&&*(a+1)=='D'&&*(a+2)=='3') { /*判断是否是id3v2标签*/
        version=*(a+3);
        size[0]=*(a+6);
        if (size[0]<0)size[0]+=256;
        size[1]=*(a+7);
        if (size[1]<0)size[1]+=256;
        size[2]=*(a+8);
        if (size[2]<0)size[2]+=256;
        size[3]=*(a+9);
        if (size[3]<0)size[3]+=256;
        i=(size[0]&0x7F)*0x200000+(size[1]&0x7F)*0x4000+(size[2]&0x7F)*0x80+(size[3]&0x7F);
        header_size=i;
        free(a);
        a=malloc(i);
        if (!fread(a,i,1,file)) {
            //printf("get_id3v2_tag error:read file error.....size=%ld\n",i);
            return NULL;
        };
        c=a;
        if (version==3) { /*如果是id3v2.3标签*/
            for (;c!=a+header_size;) { /*循环读取每个标签*/
                if (*tag[0]!=0&&*tag[1]!=0&&*tag[2]!=0)return tag_;
                strcpy(b,c);
                b[4]=0;
                tag_type=0;
                size[0]=*(c+4);
                if (size[0]<0)size[0]+=256;
                size[1]=*(c+5);
                if (size[1]<0)size[1]+=256;
                size[2]=*(c+6);
                if (size[2]<0)size[2]+=256;
                size[3]=*(c+7);
                if (size[3]<0)size[3]+=256;
                i=size[0]*0x1000000+size[1]*0x10000+size[2]*0x100+size[3];
                if (i<0)i+=256;
                if ((c+i)>(a+header_size))break;
                if (i==0)break;
                tag_type=0;
                if (!strcmp(b,"TPE1"))tag_type=1;
                if (!strcmp(b,"TALB"))tag_type=2;
                if (!strcmp(b,"TIT2"))tag_type=3;
                if (!tag_type) {
                    c+=i+10;
                    continue;
                };
                c+=10;
                d=(gchar*)malloc(i+1);
                for (j=0;i!=0;i--) {

                    if (*c!=0) {
                        d[j]=*c;
                        j++;
                    }
                    c++;
                };
                d[j]=0;
                if (g_utf8_validate(d,-1,NULL))
                    strcpy(tag[tag_type-1],d);
                else {
                    tag_[tag_type-1]=g_convert(d,-1,"UTF-8","GBK",&r,&w,NULL);

                    //free(tag[tag_type-1]);
                };
            };
            if (tag_[0]==NULL&&tag_[1]==NULL&&tag_[2]==NULL)return NULL;
            return tag_;
        } else if (version==2) { /*如果是id3v2.2标签*/
            for (;c!=a+header_size;) { /*循环读取每个标签*/
                if (*tag[0]!=0&&*tag[1]!=0&&*tag[2]!=0)return tag_;
                strcpy(b,c);
                b[3]=0;
                size[0]=*(c+3);
                size[1]=*(c+4);
                size[2]=*(c+5);
                i=size[0]*0x10000+size[1]*0x100+size[2];
                if (i<0)i+=256;
                if ((c+i)>(a+header_size))break;
                if (i==0)break;
                tag_type=0;
                if (!strcmp(b,"TP1"))tag_type=1;
                if (!strcmp(b,"TAL"))tag_type=2;
                if (!strcmp(b,"TT2"))tag_type=3;
                if (!tag_type) {
                    c+=i+6;
                    continue;
                };
                c+=6;
                d=(gchar*)malloc(i);
                for (j=0;i!=0;i--) {

                    if (*c==0) {
                        c++;
                        continue;
                    }
                    d[j]=*c;
                    j++;
                    c++;
                };
                d[j]=0;

                if (g_utf8_validate(d,-1,NULL))
                    strcpy(tag[tag_type-1],d);
                else {
                    tag_[tag_type-1]=g_convert(d,-1,"UTF-8","GBK",&r,&w,NULL);
                    //free(tag[tag_type-1]);
                };

            };
            if (tag_[0]==NULL&&tag_[1]==NULL&&tag_[2]==NULL)return NULL;
            return tag_;
        };
    };
    return NULL;
}
gchar **get_tag(gchar *filename) {

    FILE *file;
    static gchar **tag;
    file=fopen(filename,"rb");
    if (!file) {
        //printf("can't open file %s\n",filename);
        return NULL;
    }
    tag=get_id3v2_tag(file);/*获取id2v2标签,如果返回的是空值,就获取id3v1标签*/
    if (tag==NULL) {
        rewind(file);
        tag=get_id3v1_tag(file);
    }
    return tag;
}
static void on_id3_button_prev_clicked  (GtkButton *button,gpointer user_data) {
    GtkTreeModel *model= gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkTreeIter iter;
    list_number=0;

    gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
    gtk_tree_path_prev(id3.id3_path);
    gtk_tree_model_get_iter(model, &iter, id3.id3_path) ;
    gchar *value;
    gtk_tree_model_get(model, &iter, 0, &value, -1);
    gchar data[2000];
    FILE *list_file = fopen(list_file_path,"a+");
    while (fgets(data,2000,list_file)) {
        data[strlen(data)-1] = '\0';
        if (strcmp(data,value) ==0) {
            if (fgets(data,2000,list_file));
            data[strlen(data)-1] = '\0';
            gint n = strlen(data);
            gint m = 0;
            while (m+7 != n) {
                data[m] = data[m+7];
                m++;
            }
            data[m] = '\0';
            break;
        }
    }

    if (list_file) {
        fclose(list_file);
        list_file=0;
    }
    gchar **tag=get_tag(data);
    if (tag!=NULL&&*tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_artist,*tag++);
    if (tag!=NULL&&*tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_album,*tag++);
    if (tag!=NULL&&*tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_title,*tag);
    gchar folder[2000];
    gchar name[200];
    gchar suffix[200];
    strcpy(folder,data);
    gint a=strlen(data);
    while (folder[a]!='/'&&a!=0)
        a--;
    if (a!=0) {
        folder[a]=0;
        gint b=0;
        a++;
        while (data[a]!='.'&&data[a]!=0)
            name[b++]=data[a++];
        name[b]=0;
        if (data[a]) {
            gint b=0;
            while (data[a]!=0)
                suffix[b++]=data[a++];
            suffix[b]=0;
            gtk_entry_set_text((GtkEntry *)id3.entry_suffix,suffix);
        }

        gtk_entry_set_text((GtkEntry *)id3.entry_folder,folder);
        gtk_entry_set_text((GtkEntry *)id3.entry_name,name);
    }
}
static void on_id3_button_next_clicked  (GtkButton *button,gpointer user_data) {
    GtkTreeModel *model= gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkTreeIter iter;
    list_number=0;

    gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
    gtk_tree_path_next(id3.id3_path);
    gchar *b=gtk_tree_path_to_string(id3.id3_path);
    gint a= atoi(b);
    if (a>=list_number) {
        gtk_tree_path_prev(id3.id3_path);
    }
    gtk_tree_model_get_iter(model, &iter, id3.id3_path) ;
    gchar *value;
    gtk_tree_model_get(model, &iter, 0, &value, -1);
    gchar data[2000];
    FILE *list_file = fopen(list_file_path,"a+");
    while (fgets(data,2000,list_file)) {
        data[strlen(data)-1] = '\0';
        if (strcmp(data,value) ==0) {
            if (fgets(data,2000,list_file));
            data[strlen(data)-1] = '\0';
            gint n = strlen(data);
            gint m = 0;
            while (m+7 != n) {
                data[m] = data[m+7];
                m++;
            }
            data[m] = '\0';
            break;
        }
    }

    if (list_file) {
        fclose(list_file);
        list_file=0;
    }
    gchar **tag=get_tag(data);
    if (tag!=NULL&&*tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_artist,*tag++);
    if (tag!=NULL&&*tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_album,*tag++);
    if (tag!=NULL&&*tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_title,*tag);
    gchar folder[2000];
    gchar name[200];
    gchar suffix[200];
    strcpy(folder,data);
    a=strlen(data);
    while (folder[a]!='/'&&a!=0)
        a--;
    if (a!=0) {
        folder[a]=0;
        gint b=0;
        a++;
        while (data[a]!='.'&&data[a]!=0)
            name[b++]=data[a++];
        name[b]=0;
        if (data[a]) {
            gint b=0;
            while (data[a]!=0)
                suffix[b++]=data[a++];
            suffix[b]=0;
            gtk_entry_set_text((GtkEntry *)id3.entry_suffix,suffix);
        }

        gtk_entry_set_text((GtkEntry *)id3.entry_folder,folder);
        gtk_entry_set_text((GtkEntry *)id3.entry_name,name);
    }
}
static void on_id3_button_save_clicked  (GtkButton *button,gpointer user_data) {
    gtk_widget_destroy(id3.id3_editor);
}
static void show_id3(gchar path[2000]) {
    gchar **tag=get_tag(path);

    id3.id3_editor = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (id3.id3_editor), "Iceplayer Id3 Editor Beta");
    gtk_window_set_position (GTK_WINDOW (id3.id3_editor), GTK_WIN_POS_CENTER);
    gtk_window_set_resizable (GTK_WINDOW (id3.id3_editor), FALSE);

    id3.vbox = gtk_vbox_new (FALSE, 0);
    gtk_widget_show (id3.vbox);
    gtk_container_add (GTK_CONTAINER (id3.id3_editor), id3.vbox);
    gtk_container_set_border_width (GTK_CONTAINER (id3.vbox), 9);

    id3.hbox = gtk_hbox_new (FALSE, 0);
    gtk_widget_show (id3.hbox);
    gtk_box_pack_start (GTK_BOX (id3.vbox), id3.hbox, FALSE, FALSE, 0);

    id3.label_path = gtk_label_new ("文件");
    gtk_widget_show (id3.label_path);
    gtk_box_pack_start (GTK_BOX (id3.hbox), id3.label_path, FALSE, FALSE, 0);

    id3.entry_folder = gtk_entry_new ();
    gtk_widget_show (id3.entry_folder);
    gtk_box_pack_start (GTK_BOX (id3.hbox), id3.entry_folder, TRUE, TRUE, 0);
    gtk_widget_set_size_request (id3.entry_folder, 150, 20);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_folder), 9679);

    id3.entry_name = gtk_entry_new ();
    gtk_widget_show (id3.entry_name);
    gtk_box_pack_start (GTK_BOX (id3.hbox), id3.entry_name, FALSE, FALSE, 0);
    gtk_widget_set_size_request (id3.entry_name, 150, 20);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_name), 9679);

    id3.entry_suffix = gtk_entry_new ();
    gtk_widget_show (id3.entry_suffix);
    gtk_box_pack_start (GTK_BOX (id3.hbox), id3.entry_suffix, FALSE, FALSE, 0);
    gtk_widget_set_size_request (id3.entry_suffix, 60, 20);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_suffix), 9679);

    id3.table = gtk_table_new (7, 2, FALSE);
    gtk_widget_show (id3.table);
    gtk_box_pack_start (GTK_BOX (id3.vbox), id3.table, FALSE, FALSE, 0);

    id3.label_title = gtk_label_new ("标题");
    gtk_widget_show (id3.label_title);
    gtk_table_attach (GTK_TABLE (id3.table), id3.label_title, 0, 1, 0, 1, (GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment (GTK_MISC (id3.label_title), 0, 0.5);

    id3.label_atrist = gtk_label_new ("作者");
    gtk_widget_show (id3.label_atrist);
    gtk_table_attach (GTK_TABLE (id3.table), id3.label_atrist, 0, 1, 1, 2, (GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment (GTK_MISC (id3.label_atrist), 0, 0.5);

    id3.label_album = gtk_label_new ("专辑");
    gtk_widget_show (id3.label_album);
    gtk_table_attach (GTK_TABLE (id3.table), id3.label_album, 0, 1, 2, 3, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment (GTK_MISC (id3.label_album), 0, 0.5);

    id3.label_year = gtk_label_new ("年份");
    gtk_widget_show (id3.label_year);
    gtk_table_attach (GTK_TABLE (id3.table), id3.label_year, 0, 1, 3, 4, (GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment (GTK_MISC (id3.label_year), 0, 0.5);

    id3.label_genre = gtk_label_new ("风格");
    gtk_widget_show (id3.label_genre);
    gtk_table_attach (GTK_TABLE (id3.table), id3.label_genre, 0, 1, 4, 5,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment (GTK_MISC (id3.label_genre), 0, 0.5);

    id3.label_track = gtk_label_new ("轨道");
    gtk_widget_show (id3.label_track);
    gtk_table_attach (GTK_TABLE (id3.table), id3.label_track, 0, 1, 5, 6,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment (GTK_MISC (id3.label_track), 0, 0.5);

    id3.label_comment = gtk_label_new ("注释");
    gtk_widget_show (id3.label_comment);
    gtk_table_attach (GTK_TABLE (id3.table), id3.label_comment, 0, 1, 6, 7,(GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
    gtk_misc_set_alignment (GTK_MISC (id3.label_comment), 0, 0.5);

    id3.entry_comment = gtk_entry_new ();
    gtk_widget_show (id3.entry_comment);
    gtk_table_attach (GTK_TABLE (id3.table), id3.entry_comment, 1, 2, 6, 7, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_comment), 9679);

    id3.entry_track = gtk_entry_new ();
    gtk_widget_show (id3.entry_track);
    gtk_table_attach (GTK_TABLE (id3.table), id3.entry_track, 1, 2, 5, 6, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),(GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_track), 9679);

    id3.entry_year = gtk_entry_new ();
    gtk_widget_show (id3.entry_year);
    gtk_table_attach (GTK_TABLE (id3.table), id3.entry_year, 1, 2, 3, 4,(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),  (GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_year), 9679);

    id3.entry_artist = gtk_entry_new ();
    gtk_widget_show (id3.entry_artist);
    gtk_table_attach (GTK_TABLE (id3.table), id3.entry_artist, 1, 2, 1, 2, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_artist), 9679);
    if (tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_artist,*tag++);

    id3.entry_album = gtk_entry_new ();
    gtk_widget_show (id3.entry_album);
    gtk_table_attach (GTK_TABLE (id3.table), id3.entry_album, 1, 2, 2, 3, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),(GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_album), 9679);
    if (tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_album,*tag++);

    id3.entry_title = gtk_entry_new ();
    gtk_widget_show (id3.entry_title);
    gtk_table_attach (GTK_TABLE (id3.table), id3.entry_title, 1, 2, 0, 1,(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),(GtkAttachOptions) (0), 0, 0);
    gtk_entry_set_invisible_char (GTK_ENTRY (id3.entry_title), 9679);
    if (tag!=NULL)gtk_entry_set_text((GtkEntry *)id3.entry_title,*tag++);

    id3.combobox_genre = gtk_combo_box_new_text ();
    gtk_widget_show (id3.combobox_genre);
    gtk_table_attach (GTK_TABLE (id3.table), id3.combobox_genre, 1, 2, 4, 5, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (GTK_FILL), 0, 0);

    id3.hbuttonbox = gtk_hbutton_box_new ();
    gtk_widget_show (id3.hbuttonbox);
    gtk_box_pack_start (GTK_BOX (id3.vbox), id3.hbuttonbox, FALSE, FALSE, 0);
    gtk_button_box_set_layout (GTK_BUTTON_BOX (id3.hbuttonbox), GTK_BUTTONBOX_EDGE);

    id3.button_prev = gtk_button_new_from_stock ("gtk-media-previous");
    gtk_widget_show (id3.button_prev);
    gtk_container_add (GTK_CONTAINER (id3.hbuttonbox), id3.button_prev);
    GTK_WIDGET_SET_FLAGS (id3.button_prev, GTK_CAN_DEFAULT);
    gtk_button_set_relief (GTK_BUTTON (id3.button_prev), GTK_RELIEF_NONE);

    id3.button_next = gtk_button_new_from_stock ("gtk-media-next");
    gtk_widget_show (id3.button_next);
    gtk_container_add (GTK_CONTAINER (id3.hbuttonbox), id3.button_next);
    GTK_WIDGET_SET_FLAGS (id3.button_next, GTK_CAN_DEFAULT);
    gtk_button_set_relief (GTK_BUTTON (id3.button_next), GTK_RELIEF_NONE);

    id3.button_save = gtk_button_new_from_stock ("gtk-close");
    gtk_widget_show (id3.button_save);
    gtk_container_add (GTK_CONTAINER (id3.hbuttonbox), id3.button_save);
    GTK_WIDGET_SET_FLAGS (id3.button_save, GTK_CAN_DEFAULT);
    gtk_button_set_relief (GTK_BUTTON (id3.button_save), GTK_RELIEF_NONE);

    g_signal_connect ((gpointer) id3.button_prev, "clicked",G_CALLBACK (on_id3_button_prev_clicked), NULL);
    g_signal_connect ((gpointer) id3.button_next, "clicked",G_CALLBACK (on_id3_button_next_clicked),NULL);
    g_signal_connect ((gpointer) id3.button_save, "clicked",G_CALLBACK (on_id3_button_save_clicked),NULL);

    gtk_widget_grab_focus (id3.button_next);


    gchar folder[2000];
    gchar name[200];
    gchar suffix[200];
    strcpy(folder,path);
    gint a=strlen(path);
    while (folder[a]!='/'&&a!=0)
        a--;
    if (a!=0) {
        folder[a]=0;
        gint b=0;
        a++;
        while (path[a]!='.'&&path[a]!=0)
            name[b++]=path[a++];
        name[b]=0;
        if (path[a]) {
            gint b=0;
            while (path[a]!=0)
                suffix[b++]=path[a++];
            suffix[b]=0;
            gtk_entry_set_text((GtkEntry *)id3.entry_suffix,suffix);
        }

        gtk_entry_set_text((GtkEntry *)id3.entry_folder,folder);
        gtk_entry_set_text((GtkEntry *)id3.entry_name,name);
    }

    gtk_entry_set_editable((GtkEntry *)id3.entry_folder,FALSE);
    gtk_entry_set_editable((GtkEntry *)id3.entry_name,FALSE);
    gtk_entry_set_editable((GtkEntry *)id3.entry_suffix,FALSE);

    gtk_entry_set_editable((GtkEntry *)id3.entry_album,FALSE);
    gtk_entry_set_editable((GtkEntry *)id3.entry_artist,FALSE);
    gtk_entry_set_editable((GtkEntry *)id3.entry_title,FALSE);

    gtk_widget_set_sensitive((GtkWidget *)id3.entry_comment,FALSE);
    gtk_widget_set_sensitive((GtkWidget *)id3.entry_track,FALSE);
    gtk_widget_set_sensitive((GtkWidget *)id3.entry_year,FALSE);

    gtk_widget_show_all(id3.id3_editor);
}
void edit_id3() {
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkTreeIter iter;
    GList *list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview))),&model);
    gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data) ;
    gchar *value;
    gtk_tree_model_get(model, &iter, 0, &value, -1);
    id3.id3_path = gtk_tree_path_copy((GtkTreePath *) list->data);
    gchar data[2000];
    FILE *list_file = fopen(list_file_path,"a+");
    while (fgets(data,2000,list_file)) {
        data[strlen(data)-1] = '\0';
        if (strcmp(data,value) ==0) {
            if (fgets(data,2000,list_file));
            data[strlen(data)-1] = '\0';
            gint n = strlen(data);
            gint m = 0;
            while (m+7 != n) {
                data[m] = data[m+7];
                m++;
            }
            data[m] = '\0';
            break;
        }
    }
    if (list_file) {
        fclose(list_file);
        list_file=0;
    }
    show_id3(data);
}
